#!/usr/bin/env python
# -*- coding: UTF-8 -*-

try:
	import os
	import sys
	import getopt
	import string
	import urllib
	import pygtk
	pygtk.require('2.0')
	import gtk
	import gtk.glade
	
except:
	print("Can't load some libs. Terminating program...")
	sys.exit(1)

BASE_URL = "http://weather.noaa.gov/pub/data/observations/metar/stations/"

def read_config():
	
	try:
		fh = open("metar.cfg", "r")
		ikao = fh.readline()
		fh.close ()
		
		ikao = ikao.strip("\n")
		
		return ikao
	except:
		print("Can't read cfg file. Program terminated...")
		sys.exit(1)

def get_metar(station):
 
    url = BASE_URL + (station + ".TXT")
    
    try:
        urlh = urllib.urlopen(url)
        for line in urlh:
            metar = line.strip()
        if not metar:
            metar = "!EMPTY!"
    except:
        print "Can't open requested METAR"
        sys.exit(1)   

    return metar
    
class App:

	def __init__(self):	
				
		self.gladefile = "ui.glade"
		self.widgetsTree = gtk.glade.XML(self.gladefile)
		
		dic = {
			 	"exit_button_clicked_cb" : self.close_app,
			 	"get_metar_clicked_cb" : self.refresh_metar
			}
		
		self.widgetsTree.signal_autoconnect(dic)
		self.window = self.widgetsTree.get_widget("main_dialog")
		self.metar_report = self.widgetsTree.get_widget("metar_report")
		self.metar_ikao = self.widgetsTree.get_widget("metar_ikao")
		if (self.window):
			self.window.connect("destroy", self.close_app)
		
		ikao = read_config()
		
		self.metar_ikao.set_text(ikao)
		self.metar_report.set_text("METAR REPORT FOR: " + get_metar(ikao))

	def close_app(self, widget):
	
		gtk.main_quit()
	
	def refresh_metar(self, widget):

		self.metar_report.set_text("METAR REPORT FOR: " + get_metar(self.metar_ikao.get_text()))

if __name__ == "__main__":
	App = App()
	gtk.main()
